
%%% Create_Data_Demo_PSO


%%% Number of dimensions in the problem (number of unknowns)
  if (exist('Option_Fuzzy_Line_Triangle_Circle')==1)
        if Option_Fuzzy_Line_Triangle_Circle==3
        dims=Nb_Circle*2; %%% 2 parameters for each blurred circle
        else
        dims=length(theta)*3; %%% 3 parameters for each blurred line
        end
  end
  

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%% Set of possible functions to optimize
functnames = {'ackley','alpine','DeJong_f2','DeJong_f3','DeJong_f4',...
              'Foxhole','Griewank','NDparabola',...
              'Rastrigin','Rosenbrock','f6','f6mod','tripod',...
              'f6_bubbles_dyn','f6_linear_dyn','f6_spiral_dyn',...
              'Complex_Signal_Norm'};



%%% Function to optimize
functname = functnames{functchc};


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Plot options
if plotfcn == 1
   plotfcn = 'goplotpso4demo';
   shw     = 1;   % how often to update display
elseif plotfcn == 2
   plotfcn = 'goplotpso';
   shw     = 1;   % how often to update display
else
   plotfcn = 'goplotpso';
   shw     = 0;   % how often to update display
end
   

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% set flag for 'dynamic function on', only used at very end for tracking plots
dyn_on = 0;
if functchc==15 | functchc == 16 | functchc == 17
   dyn_on = 1;
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Min or Max search
%%%
% note: if errgoal=NaN then unconstrained min or max is performed
  if minmax==1
    %  errgoal=0.97643183; % max for f6 function (close enough for termination)
      errgoal=NaN;
  else
     % errgoal=0; % min
      errgoal=NaN;
  end
  minx = xrng(1);
  maxx = xrng(2);
  miny = yrng(1);
  maxy = yrng(2);
  
  
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Taking into account the max velocity search
  varrange=[];
  mv=[];
  for i=1:dims
  if floor(i/2)~=i/2%%% Odd indices: radii of concentric circles
      varrange=[varrange;minx maxx];
  elseif floor(i/2)==i/2%%% Even indices: sigma of concentric circles
      varrange=[varrange;miny maxy];
     
  end
  
      
      mv=[mv;(varrange(i,2)-varrange(i,1))/mvden];
  end
   
  %%% varrange can also be defined as:
%       [ min1 max1 
%         min2 max2
%            ...
%         minD maxD ]
  
  
  
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Parameter for the iterative optimization method
   % starting particle positions (first 20 at zero, just for an example)
   PSOseedValue = repmat([0],ps-10,1);
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Store the PSO parameters (defined in teh setup) in a vector
psoparams=...
   [shw epoch ps ac(1) ac(2) Iwt(1) Iwt(2) ...
    wt_end errgrad errgraditer errgoal modl PSOseed];

  
  
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% Creation of the test signal:
%%%%%%%%% We wish to find the parameters which characterize this test
%%%%%%%%% signal.
%%%
% 
% global Test_Signal
% 
% Test_Signal=Compute_Signal(Set_Unknow_Values);
% %%% Test signal is expressed analytically in the function 'Compute_Signal'.
% 
%   
  
  
  
  
  
  
  
  
  
  
  