
%%% Create_Data_PSO


%%% Number of dimensions in the problem (number of unknowns)
  dims=2;%%% 1 if we only look for sigma.

  if (exist('Option_Fuzzy_Line_Triangle_Circle')==1)
        if Option_Fuzzy_Line_Triangle_Circle==3
        dims=Nb_Circle*2; %%% 2 parameters for each blurred circle
        else
        dims=length(theta)*3; %%% 3 parameters for each blurred line
        end
  end
  

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%% Set of possible functions to optimize
functnames = {'ackley','alpine','DeJong_f2','DeJong_f3','DeJong_f4',...
              'Foxhole','Griewank','NDparabola',...
              'Rastrigin','Rosenbrock','f6','f6mod','tripod',...
              'f6_bubbles_dyn','f6_linear_dyn','f6_spiral_dyn',...
              'Complex_Signal_Norm',String_Criterion_Function_for_Blurred_Contours};



%%% Function to optimize
functname = functnames{functchc};
%%% If a blurred contour is expected, functname is created inside the
%%% programme for the estimation of the contour parameters.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Plot options
if plotfcn == 1
   plotfcn = 'goplotpso4demo';
   shw     = 1;   % how often to update display
elseif plotfcn == 2
   plotfcn = 'goplotpso';
   shw     = 1;   % how often to update display
else
   plotfcn = 'goplotpso';
   shw     = 0;   % how often to update display
end
   

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% set flag for 'dynamic function on', only used at very end for tracking plots
dyn_on = 0;
if functchc==15 | functchc == 16 | functchc == 17
   dyn_on = 1;
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Min or Max search
%%%
% note: if errgoal=NaN then unconstrained min or max is performed
  if minmax==1
    %  errgoal=0.97643183; % max for f6 function (close enough for termination)
      errgoal=NaN;
  else
     % errgoal=0; % min
      errgoal=NaN;
  end

 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Taking into account the max velocity search
  varrange=[];
  mv=[];

%   minsigma = sigmarng(1);
%   maxsigma = sigmarng(2);
  
  repsigmarng=repmat(sigmarng,dims,1);
   
if  Option_Fuzzy_Line_Triangle_Circle==3                %%% blurred Circles  
    repradiusrng=repmat(radiusrng,dims,1);
    %%%% Old
%   minradius = radiusrng(1);
%   maxradius = radiusrng(2);
%   
%   for i=1:dims
%   if floor(i/2)~=i/2%%% Odd indices: radii of concentric circles
%       varrange=[varrange;minradius maxradius];
%   elseif floor(i/2)==i/2%%% Even indices: sigma of concentric circles
%       varrange=[varrange;minsigma maxsigma];
%      
%   end
%   
%   end
    %%%% End Old


    Nb_Parameters=2;
    varrange=zeros(dims,2);
    for Ind_Contour=1:dims/Nb_Parameters  
        varrange((Ind_Contour-1)*Nb_Parameters+1,:)=repradiusrng(Ind_Contour,:);
        varrange((Ind_Contour-1)*Nb_Parameters+2,:)=repsigmarng(Ind_Contour,:);

    end



elseif  Option_Fuzzy_Line_Triangle_Circle==1                %%% blurred lines
    repthetarng=repmat(thetarng,dims,1);
    repoffsetrng=repmat(offsetrng,dims,1);

    Nb_Parameters=3;
    varrange=zeros(dims,2);
    for Ind_Contour=1:dims/Nb_Parameters  
        varrange((Ind_Contour-1)*Nb_Parameters+1,:)=repthetarng(Ind_Contour,:);
        varrange((Ind_Contour-1)*Nb_Parameters+2,:)=repoffsetrng(Ind_Contour,:);
        varrange((Ind_Contour-1)*Nb_Parameters+3,:)=repsigmarng(Ind_Contour,:);

    end

end
  
  
for i=1:dims
      mv=[mv;(varrange(i,2)-varrange(i,1))/mvden];
end
  
    varrange
    
    pause

    
  %%% May be needed for the display: we use the first two unknown variables.  
  minx = varrange(1,1);
  maxx = varrange(1,2);
  miny = varrange(2,1);
  maxy = varrange(2,2);

        
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Parameter for the iterative optimization method
   % starting particle positions (first 20 at zero, just for an example)
   PSOseedValue = repmat([0],ps-10,1);
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Store the PSO parameters (defined in teh setup) in a vector
psoparams=...
   [shw epoch ps ac(1) ac(2) Iwt(1) Iwt(2) ...
    wt_end errgrad errgraditer errgoal modl PSOseed];

  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  