%%% Setup_PSO


functchc = ?;
% 
%%%% Original PSO demo functions:
% disp('Static test functions, minima don''t change w.r.t. time/iteration:');
% disp(' 1) Ackley');
% disp(' 2) Alpine');
% disp(' 3) DeJong_f2');
% disp(' 4) DeJong_f3');
% disp(' 5) DeJong_f4');
% disp(' 6) Foxhole');
% disp(' 7) Griewank');
% disp(' 8) NDparabola (for this demo N = 2)');
% disp(' 9) Rastrigin');
% disp('10) Rosenbrock');
% disp('11) Schaffer f6');
% disp('12) Schaffer f6 modified (5 f6 functions translated from each other)');
% disp('13) Tripod');
% disp(' ');
% disp('Dynamic test functions, minima/environment evolves over time/iteration:');
% disp('14) f6_bubbles_dyn');
% disp('15) f6_linear_dyn');
% disp('16) f6_spiral_dyn');


%%% Number of dimensions in the problem (number of unknowns)
dims=?;


xrng=[-15,15];
yrng=[-15,15];
%
% Input search range: we need at least two for the display.
%%% These are the limits for the even-indexed unknowns in Set_Unknow_Values
%%% and for the odd-indexed values in Set_Unknow_Values respectively


minmax=0
% 
% input('Choose search goal ?')
% disp('0) Minimize')
% disp('1) Maximize')

mvden = 2; 
%
% input('Max velocity divisor (2 is a good choice) ? ')

ps    = ?;
%
% input('How many particles (24 - 30 is common)? ')


modl  = 0;
% 
%   input('Choose PSO model ? ')
%   disp('0) Common PSO - with inertia');
%   disp('1) Trelea model 1');
%   disp('2) Trelea model 2');
%   disp('3) Clerc Type 1" - with constriction');


%%% Parameters of PSO optimization
ac      = [2.1,2.1];% acceleration constants, only used for modl=0
Iwt     = [0.9,0.6];  % intertia weights, only used for modl=0

%%% Parameters for the iterative algorithm
epoch   = ?; % max iterations
wt_end  = 50; % iterations it takes to go from Iwt(1) to Iwt(2), only for modl=0
errgrad = 1e-6;   % lowest error gradient tolerance
errgraditer=100; % max # of epochs without error change >= errgrad
PSOseed = 0;    % if=1 then can input particle starting positions, if= 0 then all random
  

plotfcn = 1
%
% input('Choose plotting function ? ')
% disp('1) Intense graphics, shows error topology and surfing particles');
% disp('2) Default PSO graphing, shows error trend and particle dynamics');
% disp('3) no plot, only final output shown, fastest');






